// -------------------------------------------------------------------------------
// 
// 		cwCu		Oobt@vOwb_t@C
// 
// 				Ver 3.14c
// 
// -------------------------------------------------------------------------------

#ifndef __DXRINGBUFFER_H__
#define __DXRINGBUFFER_H__

// CN[h ------------------------------------------------------------------

#include "DxCompileConfig.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// Oobt@f[^\
struct RINGBUF
{
	char					*DataBuffer ;						// f[^̈̃|C^
	int						Start, End ;						// Lf[^̎n܂ƏI
	int						DataLength ;						// Lȃf[^̒
	int						BufferSize ;						// Oobt@̑傫
} ;

// ֐vg^Cv錾-----------------------------------------------------------

// Oobt@
extern	int			RingBufInitialize( RINGBUF * RingBuf ) ;									// Oobt@
extern	int			RingBufTerminate( RINGBUF * RingBuf ) ;										// Oobt@̌n
extern	int			RingBufDataAdd( RINGBUF * RingBuf, const void *Data, int Len ) ;			// Oobt@Ƀf[^ǉ
extern	int			RingBufDataGet( RINGBUF * RingBuf, void *Buf, int Len, int PeekFlag) ;		// Oobt@f[^ǂ݂
extern	int			RingBufGetDataLength( RINGBUF * RingBuf ) ;									// Oobt@̗Lf[^ʂ̎擾 
extern	int			RingBufGetRestDataLength( RINGBUF * RingBuf ) ;								// Oobt@̎c󂫃f[^̈擾
extern	int			RingBufReSize( RINGBUF * RingBuf, int AddSize ) ;							// Oobt@̗eʂwʂ̃f[^ǉĂ܂TCYɒ

// Oobt@̃AhXɕsȂ`FbN
__inline void RingBufAddressCheck( RINGBUF * RingBuf )
{
	if( RingBuf->Start == RingBuf->BufferSize ) RingBuf->Start = 0 ;
	if( RingBuf->End == RingBuf->BufferSize ) RingBuf->End = 0 ;
}

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXRINGBUFFER_H__

