// -------------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSpTEhvOwb_t@C
// 
// 				Ver 3.14c
// 
// -------------------------------------------------------------------------------

#ifndef __DXSOUNDWIN_H__
#define __DXSOUNDWIN_H__

// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include "../DxLib.h"
#include "DxDirectX.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define D_X3DAUDIO_INPUTCHANNELS		(8)				// X3DAudio ̌vZŎgpő̓`l

// \̒` --------------------------------------------------------------------

// XAudio2pR[obNp\
struct SOUNDBUFFER_CALLBACK : public D_IXAudio2VoiceCallback
{
	virtual void    __stdcall OnVoiceProcessingPassStart( DWORD BytesRequired ) ;
	virtual void    __stdcall OnVoiceProcessingPassEnd	() ;
	virtual void    __stdcall OnStreamEnd				() ;
	virtual void    __stdcall OnBufferStart				( void* pBufferContext ) ;
	virtual void    __stdcall OnBufferEnd				( void* pBufferContext ) ;
	virtual void    __stdcall OnLoopEnd					( void* pBufferContext ) ;
	virtual void    __stdcall OnVoiceError				( void* pBufferContext, HRESULT Error ) ;

	struct SOUNDBUFFER			*Buffer ;
} ;

// TEhobt@ˑ\
struct SOUNDBUFFER_PF
{
	union
	{
		D_IDirectSoundBuffer 		*DSBuffer ;				// DirectSoundBuffer
		D_IXAudio2SourceVoice		*XA2SourceVoice ;		// XAudio2SourceVoice
		D_IXAudio2_8SourceVoice		*XA2_8SourceVoice ;		// XAudio2_8SourceVoice
	} ;
	union
	{
		D_IXAudio2SubmixVoice		*XA2SubmixVoice ;		// XAudio2SubmixVoice
		D_IXAudio2_8SubmixVoice		*XA2_8SubmixVoice ;		// XAudio2_8SubmixVoice
	} ;
	IUnknown					*XA2ReverbEffect ;		// o[uGtFNg
	SOUNDBUFFER_CALLBACK		*XA2Callback ;			// XAudio2p̃R[obN

	union
	{
		D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameter ;	// o[uvZpp[^
		D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameter ;	// o[uvZpp[^XAudio2.8p
	} ;

	int							XAudioChannels ;		// XAudio ł̃`l

	// RcTEhĐpf[^
	D_X3DAUDIO_EMITTER			X3DAudioEmitterData ;									// RcTEhp
	D_X3DAUDIO_CONE				X3DAudioEmitterConeData ;								// RcTEhpŎgpR[
	float						X3DAudioEmitterChannelAzimuths[ D_X3DAUDIO_INPUTCHANNELS ] ;	// RcTEhpŎgp`lʒue[u
} ;

// TEhVXepˑf[^\
struct SOUNDSYSTEMDATA_PF
{
	D_IDirectMusicLoader8		*DirectMusicLoaderObject ;		// DirectMusicLoader8 IuWFNg
	D_IDirectMusicPerformance8	*DirectMusicPerformanceObject ;	// DirectMusicPerformance8 IuWFNg

	HMODULE						XAudio2_8DLL ;					// XAudio2_8.dll
	HRESULT						( WINAPI *XAudio2CreateFunc )( D_IXAudio2_8 ** ppXAudio2, DWORD Flags, D_XAUDIO2_PROCESSOR XAudio2Processor );
	HRESULT						( WINAPI *CreateAudioVolumeMeterFunc )( IUnknown** ppApo ) ;
	HRESULT						( WINAPI *CreateAudioReverbFunc )( IUnknown** ppApo ) ;

	HMODULE						X3DAudioDLL ;					// X3DAudio.dll
	void						( __cdecl *X3DAudioInitializeFunc )( DWORD SpeakerChannelMask, float SpeedOfSound, D_X3DAUDIO_HANDLE Instance ) ;
	void						( __cdecl *X3DAudioCalculateFunc )( const D_X3DAUDIO_HANDLE Instance, const D_X3DAUDIO_LISTENER* pListener, const D_X3DAUDIO_EMITTER* pEmitter, DWORD Flags, D_X3DAUDIO_DSP_SETTINGS* pDSPSettings ) ;

	union
	{
		D_IXAudio2				*XAudio2Object ;				// XAudio2IuWFNg
		D_IXAudio2_8			*XAudio2_8Object ;				// XAudio2_8IuWFNg
		D_IDirectSound			*DirectSoundObject ;			// crIuWFNg
	} ;

	D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^
	D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^XAudio2.8p
	D_IXAudio2MasteringVoice	*XAudio2MasteringVoiceObject ;	// XAudio2MasteringVoiceIuWFNg
	D_IXAudio2_8MasteringVoice	*XAudio2_8MasteringVoiceObject ;// XAudio2_8MasteringVoiceIuWFNg
	D_XAUDIO2_EFFECT_CHAIN		XAudio2MasteringEffectChain ;	// }X^[{CXp̃GtFNg`FC

	DWORD						XAudio2OutputChannelMask ;		// o̓`l}XN

	D_X3DAUDIO_HANDLE			X3DAudioInstance ;				// RcTEhvZpCX^Xnh
	D_X3DAUDIO_CONE				X3DAudioListenerConeData ;		// RcTEh̃Xi[ɎgpR[
	D_X3DAUDIO_LISTENER			X3DAudioListenerData ;			// RcTEh̃Xi[

	D_IDirectSoundBuffer		*PrimarySoundBuffer ;			// vC}TEhobt@
	D_IDirectSoundBuffer		*BeepSoundBuffer ;				// r[vpobt@

	D_IDirectSoundBuffer		*NoSoundBuffer ;				// obt@

	int							EnableXAudioFlag ;				// XAudiogp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ ) 
	int							UseSoftwareMixing ;				// \tgEGA~LVOsǂ̃tO( TRUE:\tgEGA  FALSE:n[hEGA )

	HANDLE						StreamSoundThreadHandle ;		// Xg[TEhĐ鏈sXbh̃nh
	DWORD						StreamSoundThreadID ;			// Xg[TEhĐ鏈sXbĥhc
	DWORD						StreamSoundThreadEndFlag ;		// Xg[TEhĐ鏈I邩ǂ̃tO
} ;

// lhchf[^ˑ
struct MIDIHANDLEDATA_PF
{
	D_IDirectMusicSegment8		*DirectMusicSegmentObject ;		// DirectMusicSegment8 IuWFNg
} ;

// lhchVXepˑf[^\
struct MIDISYSTEMDATA_PF
{
	UINT						MidiDeviceID ;					// lhcht̃foCXhc
} ;

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		MidiCallBackProcess( void ) ;																			// lhchtIĂ΂R[obN֐


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXSOUNDWIN_H__
